import es, dnd, popuplib, spe, cmdlib, random, gamethread, math
from dnd import dnd
from spe import HookAction
from spe import HookType
from spe.tools.player import SPEPlayer
from spe.tools.weapon import SPEWeapon

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('Respawn', HookType.Pre, pre_spawn)
    cmdlib.registerClientCommand('!powerattack', powerattack, 'Fighter ability - Chance to do 1.5x damage, chance to miss')
    cmdlib.registerClientCommand('!whirlwind', whirlwind, 'Fighter ability - Deals your damage to all enemies in an AOE')
    
    
    Fighter_Menu = popuplib.create('Fighter Info')
    Fighter_Menu.addline('Fighter Class Information:')
    Fighter_Menu.addline('  !powerattack - Chance to do 1.5x damage, chance to miss')
    Fighter_Menu.addline('      Rifles Only')
    Fighter_Menu.addline('  Level 3: Dual Wield - Chance to do deal damage twice, chance to miss')
    Fighter_Menu.addline('      SMGs Only')
    Fighter_Menu.addline('  Level 5: Weapon Specialization - .8% Damage Per Level (Retroactive)')
    Fighter_Menu.addline('  Level 9: !whirlwind - Your damage is applied to all enemies in an AOE')
    Fighter_Menu.addline('      Last 2 seconds, 15 second cool down')
    Fighter_Menu.addline('  Cleave - after killing an opponent, your last damage dealt is done')
    Fighter_Menu.addline('      in an AOE. (Not yet implemented)')
    Fighter_Menu.addline('-> 9. Main Menu')
    Fighter_Menu.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Fighter Info')
    spe.undetourFunction('Respawn', HookType.Pre, pre_spawn)
    cmdlib.unregisterClientCommand('!whirlwind')
    cmdlib.unregisterClientCommand('!powerattack')
    cmdlib.unregisterClientCommand('!giveLevel')
    
def pre_spawn(args):
    userid = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[0])))
    if dnd.Player(userid).getClass() == 'Fighter':
        dnd.Temp(userid).add('Fortitude', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).add('Reflex', dnd.Player(userid).getLevel()/3)
        dnd.Temp(userid).add('Will', dnd.Player(userid).getLevel()/3)
        dnd.Temp(userid).set('whirlwind', 0)
        dnd.Temp(userid).set('cool down', 0)
    return (HookAction.Continue, 0)
    
    '''
    If you were going to change someones health, you would prehook the spawn event and add it to their health.
    
        dnd.Temp(ev['userid']).add('health', 20)
        
    The reason we hook the event and add it before hand is because we set the health on spawn and change the attributes before
    they actually spawn.
    '''
    
def powerattack(userid, args):
    if dnd.Player(userid).getClass() == 'Fighter':
        if dnd.Temp(userid).get('power attack'):
            dnd.Temp(userid).set('power attack', 0)
            dnd.dndTell(userid, 'Your Power Attack has been disabled')
        else:
            dnd.dndTell(userid, 'Your Power Attack has been enabled')
            dnd.Temp(userid).set('power attack', 1)
            
def whirlwind(userid, args):
    if dnd.Player(userid).getClass() == 'Fighter' and dnd.Player(userid).getLevel() >= 9 and dnd.Player(userid).alive():
        if not dnd.Temp(userid).get('cool down') and not dnd.Temp(userid).get('whirlwind'):
            dnd.dndTell(userid, 'You have activated Whirl Wind!')
            dnd.Temp(userid).set('whirlwind', 1)
            dnd.Temp(userid).set('cool down', 1)
            gamethread.delayedname(2, 'dndtick', whirlwindoff, userid)
            gamethread.delayedname(15, 'dndtick', dnd.cooldownoff, userid)
        else:
            dnd.dndTell(userid, 'Your Whirl Wind is on Cool Down')
            
def whirlwindoff(userid):
    dnd.Temp(userid).set('whirlwind', 0)
    dnd.dndTell(userid, 'Your Whirl Wind is no longer active')

def giveLevel(userid, args):
    dnd.Player(userid).giveLevel(1)
                