import dnd, es, spe, popuplib, gamethread, playerlib
from dnd import dnd
from spe import HookAction
from spe import HookType

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('Respawn', HookType.Pre, pre_spawn)
    info = popuplib.create("Paladin Info")
    info.addline('Paladin Class Information:')
    info.addline('  Lay On Hands - When brought below 20% Health,')
    info.addline('    you are instantly healed. 1/round')
    info.addline('  Level 3: Divine Grace - Your armor gives Damage Reduction')
    info.addline('    and regenerates')
    info.addline(' Level 5: Divine Health - Increased Health')
    info.addline(' Level 9: Holy Sword - Your bullets deal magic damage')
    info.addline('-> 9. Main Menu')
    info.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Paladin Info')
    spe.undetourFunction('Respawn', HookType.Pre, pre_spawn)
    
def pre_spawn(args):
    userid = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[0])))
    if dnd.Player(userid).getClass() == 'Paladin':
        dnd.Temp(userid).add('Fortitude', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).add('Reflex', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).add('Will', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).add('Lay On Hands', 1)
        if dnd.Player(userid).getLevel() >= 5:
            dnd.Temp(userid).add('health', min(dnd.Player(userid).getLevel() * 5, 50))
    return (HookAction.Continue, 0)
        
def round_start(ev):
    armor_loop()
    for userid in es.getUseridList():
        if dnd.Player(userid).getClass() == 'Paladin':
                if dnd.Player(userid).getLevel() >= 3:
                    dnd.armorregen(ev['userid'], 3, 5)
                    
def armor_loop():
    for userid in es.getUseridList():
        if dnd.Player(userid).getClass() == 'Paladin' and not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            if dnd.Player(userid).getLevel() >= 3:
                dnd.Temp(userid).set('damage reduction', int(playerlib.getPlayer(userid).getArmor())/2)
    gamethread.delayedname(.1, 'dndtick', armor_loop)
    